<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
<topic id="author-styleguide-annotations">
  <title>Customizing Annotations in the Content Completion Assistant</title>
  <prolog>
    <metadata>
      <keywords>
        <indexterm>Framework customization<indexterm>Customizing annotations for the Content
            Completion Assistant</indexterm></indexterm>
        <indexterm>Framework customization<indexterm>Translating annotations for the Content
            Completion Assistant</indexterm></indexterm>
        <indexterm>Customizing annotations for the Content Completion Assistant</indexterm>
        <indexterm>Translating annotations for the Content Completion Assistant</indexterm>
      </keywords>
    </metadata>
  </prolog>
  <body>
    <p id="p_u1b_dgk_54b"><ph keyref="product"/> gathers documentation from the associated schemas (DTD, XML Schema,
      RelaxNG) and presents it for each element or attribute. For example, if you open the <xref
        keyref="glossentry_content-completion-assistant"><term>Content Completion
        Assistant</term></xref> for a recognized XML vocabulary, documentation is displayed for each
      element provided by the associated schema. Similar information is displayed when you hover
      over tag names presented in the <xref href="author-elements-view.dita#author-elements-view"
          ><uicontrol>Elements</uicontrol> view</xref>. If you hover over attributes in the <xref
        href="author-attributes-view.dita#author-attributes-view"><uicontrol>Attributes</uicontrol>
        view</xref> you also see information about each attribute, gathered from the same
      schema.</p>
    <p id="p_v1b_dgk_54b">If you have a <xref href="the-document-type-dialog.dita#the-document-type-dialog"
          ><term>framework</term> configuration</xref> set up for your XML vocabulary, there is a
      special XML configuration file that can be added to provide additional documentation
      information or links to additional information for certain elements and attributes.</p>
    <p id="p_w1b_dgk_54b">To provide this additional information in the <term>Content Completion Assistant</term>,
      follow these steps:<ol id="ol_x1b_dgk_54b">
        <li id="li_y1b_dgk_54b"> Create a new folder in the configuration directory for the document type. <itemgroup>
            <p id="p_z1b_dgk_54b"><b><u>Example:</u></b>
              <filepath>OXYGEN_INSTALL_DIR/frameworks/dita/styleguide</filepath></p>
          </itemgroup></li>
        <li id="li_abb_dgk_54b"> Use the <uicontrol>New</uicontrol> document wizard to create a file using the
            <uicontrol>Content Completion Styleguide</uicontrol> document template (in the <menucascade>
            <uicontrol>Framework Templates</uicontrol>
            <uicontrol>Oxygen Extensions</uicontrol>
          </menucascade> section). </li>
        <li id="li_bbb_dgk_54b"> Save the file in the folder created in step 1, using the fixed name:
            <filepath>contentCompletionElementsMap.xml</filepath>. </li>
        <li id="li_cbb_dgk_54b">
          <ph conkeyref="reusables-preferences-pages/Open-the-preferences-page"/>, go to
            <uicontrol>Document Type Association</uicontrol>, and edit the document type
          configuration for your XML vocabulary. Now you need to indicate where <ph keyref="product"
          /> will locate your mapping file by doing one of the following: <ul
            id="choices_ub3_mqw_sr">
            <li id="li_dbb_dgk_54b">In the <uicontrol>Classpath</uicontrol> tab add a link to the newly created
              folder.</li>
            <li id="li_ebb_dgk_54b">
              <p id="p_fbb_dgk_54b">In the <uicontrol>Catalogs</uicontrol> tab <xref
                  href="using-XML-Catalogs.dita#using-XML-Catalogs">add a new catalog file</xref>.
                The selected file needs to contain the
                following:<codeblock  id="codeblock_gbb_dgk_54b">&lt;?xml version="1.0" encoding="UTF-8"?>
&lt;!DOCTYPE catalog PUBLIC "-//OASIS//DTD XML Catalogs V1.1//EN" 
    "http://www.oasis-open.org/committees/entity/release/1.1/catalog.dtd">
&lt;catalog xmlns="urn:oasis:names:tc:entity:xmlns:xml:catalog">
    &lt;uri name="http://www.oxygenxml.com/{processed_dt_name}/styleguide/
contentCompletionElementsMap.xml" uri="contentCompletionElementsMap.xml"/>
&lt;/catalog></codeblock></p>
              <p id="p_hbb_dgk_54b">where <i>{processed_dt_name}</i> is the name of the document type in lower case and
                with spaces replaced by underscores.<note id="note_ibb_dgk_54b">If <ph keyref="product"/> finds a mapping
                  file in both locations, the one in the <uicontrol>Catalogs</uicontrol> tab takes
                  precedence. </note></p>
            </li>
          </ul></li>
        <li id="li_jbb_dgk_54b"> Make the appropriate changes to your custom mapping file. <itemgroup>
            <p id="p_kbb_dgk_54b"><b><u>Example:</u></b> You can look at how the DITA mapping file is configured:
                <filepath>OXYGEN_INSTALL_DIR/frameworks/dita/styleguide/contentCompletionElementsMap.xml</filepath></p>
            <p id="p_lbb_dgk_54b">The associated XML Schema contains additional details about how each element and
              attribute is used in the mapping file.</p>
          </itemgroup></li>
        <li id="li_mbb_dgk_54b"> Re-open the application and open an XML document.  </li>
      </ol></p>
    <p id="p_nbb_dgk_54b">In the <xref keyref="glossentry_content-completion-assistant"><term>Content Completion
          Assistant</term></xref>, you should see the additional annotations for each element.</p>
    <section id="section_qv3_qv4_thb">
      <title>Translating Annotations</title>
      <p id="p_obb_dgk_54b">Annotations in the Content Completion Assistant can be displayed in
        various languages. Based on the language set for the interface, <ph keyref="product"/> looks
        for several filename formats to determine the information to load for the content completion
        annotations. These files that begin with the name <term>contentCompletionElementsMap</term>,
        are located in the <filepath>styleguide</filepath> folder for each built-in framework (for
        example, <filepath>OXYGEN_INSTALL_DIR/frameworks/dita/styleguide</filepath>).</p>
      <p id="p_pbb_dgk_54b">For example, for English, the files are loaded in the following order (from specific to
        more general):<ul id="ul_b3d_jx4_thb">
          <li id="li_qbb_dgk_54b"><filepath>contentCompletionElementsMap_en_US.xml</filepath> or
              <filepath>contentCompletionElementMap_en_UK.xml</filepath>, and so on</li>
          <li id="li_rbb_dgk_54b"><filepath>contentCompletionElementsMap_en.xml</filepath></li>
          <li id="li_sbb_dgk_54b"><filepath>contentCompletionElementsMap.xml</filepath></li>
        </ul></p>
      <p id="p_tbb_dgk_54b">If you want the annotations to be displayed in another language, you need to create similar
        files for the particular language. For example, to show annotations in German, create a file
        with one of the following names (and store it in the <filepath>styleguide</filepath> folder
        for your framework):<ul id="ul_ubb_dgk_54b">
          <li id="li_vbb_dgk_54b"><filepath>contentCompletionElementsMap_de_DE.xml</filepath></li>
          <li id="li_wbb_dgk_54b"><filepath>contentCompletionElementsMap_de.xml</filepath></li>
        </ul></p>
    </section>
  </body>
  <related-links>
    <linklist>
      <title>Related Information:</title>
      <link href="rendering-elements-cc-author.dita#rendering-elements-cc-author"/>
    </linklist>
  </related-links>
</topic>
